var c4 = document.getElementById("animationCanvas");
var ctx4 = c4.getContext("2d");


var zIncrement = 2;
var animateSuperBallRunning = false;


function fadeOutEffect(fadeTarget, flashCount, flashTotal, interval){
	if (!fadeTarget.style.opacity) {
		fadeTarget.style.opacity = 1;
	}
	var doFadeOut1 = setInterval(function () {
		if (fadeTarget.style.opacity > 0) {
			fadeTarget.style.opacity -= 0.1;
		}else{
			clearInterval(doFadeOut1);
			if(flashTotal !== -1){
				fadeInEffect(fadeTarget, flashCount, flashTotal, interval);
			}
		}
	}, interval);
}

function fadeInEffect(fadeTarget, flashCount, flashTotal, interval){
	var fadeNumber = fadeTarget.style.opacity;
	if (!fadeTarget.style.opacity) {
		fadeTarget.style.opacity = 0.01;
	}
	var doFadeIn1 = setInterval(function () {
		if (fadeTarget.style.opacity < 1) {
			fadeNumber = parseFloat(fadeNumber) + parseFloat('0.1');
			fadeTarget.style.opacity = fadeNumber;
		}else{
			clearInterval(doFadeIn1);
			if(flashCount < flashTotal && flashTotal !== -1){
				fadeOutEffect(fadeTarget, flashCount + 1, flashTotal, interval);
			}
		}
	}, interval);
}

function changeColorEffect(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var doFadeOut = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if(fading){
				if (fadeTarget.style.opacity > 0) {
					fadeTarget.style.opacity -= 0.1;
				}else{
					fading = false;
					clearInterval(doFadeOut);
					if(flashMax !== 0){
						changeColorEffect2(fadeTarget, flashMax, flashCount, interval);
					}
				}
			}
		}, interval);

	}

	function changeColorEffect(flashMax, flashCount, interval){
		var fading = true;
		//var fadeNumber = fadeTarget.style.opacity;
		var changeColor = setInterval(function () {
			var greenOffset = (timerColor[1] * timeScale) - 20;
			greenOffset += 80 * (timeScale);

			var redOffset = ( 255 * (1 - timeScale)); 
			redOffset += 50 * (1 - timeScale);

			if(redOffset > 255){
				redOffset = 255;
			}
			if(greenOffset > 255){
				greenOffset = 255;
			}
			if(greenOffset < 0){
				greenOffset = 0;
			}
			if(flashCount % 2 === 0){
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
			}else{
				document.getElementById("timer").style.background = 'white';
			}

			if (flashCount > flashMax) {
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
				clearInterval(changeColor);
				changeTimerColor = false;
			}
			flashCount++;
		}, interval);
	}



function levelComplete(){

 	var animateTarget = document.getElementById("canvasBlock");//.style.transform = "scaleY("+ timeScale + ")";
 	var fadeTarget = document.getElementById("timeBox");
 	//var fadeTarget2 = document.getElementById("leftSideGameBoard");
 	var fadeTarget3 = document.getElementById("rightSideGameBoard");
 	//var fadeTarget4 = document.getElementById("canvasBlock");
 	var fadeTarget5 = document.getElementById("mainGame");

 	var buttons = document.getElementsByTagName("button");
 	for(var buttonIndex = 0; buttonIndex < buttons.length; buttonIndex++){
 		var button = buttons[buttonIndex];
 		if(button.id != "nextLevel"){
 			button.disabled = true;
 			button.style.cursor = "default";
 		}
 	}




 	var scaleY = 1;
 	paused = true;
 	var startFade = false;
 	var shrinkTarget = setInterval(function () {
 		if (scaleY < 99) {
 			scaleY+= (100 - scaleY )/5;  
				//console.log("fadingDown " + animateTarget.style.opacity);
				if(scaleY > 90 && !startFade){
					startFade = true;
					fadeOutEffect1(fadeTarget, -1, -1, 50);
					fadeOutEffect1(fadeTarget2, -1, -1, 50);
					fadeOutEffect1(fadeTarget3, -1, -1, 50);
					fadeOutEffect1(fadeTarget4, -1, -1, 50);
					setTimeout(function(){
						//fadeOutEffect1(fadeTarget5, 0, 1, 20);
					}, 400);
					setTimeout(function(){
						//document.getElementById("mainGame").classList.add("mainGameBackground");
						document.getElementById("midLevelBackgroundChange").style.opacity = 1;
						
					}, 470);
					setTimeout(function(){
						showMidLevelScoreboard();
					}, 500);
				}
			}else{
				clearInterval(shrinkTarget);
			}
			return;
			document.getElementById("canvasBlock").style.transform = 'scaleY(' + (1 - (scaleY / 100) )+ ')';
			document.getElementById("canvasBlock").style.top = scaleY * 0.5 + '%';
		}, 50);

 }

 function showMidLevelScoreboard(){
 	var stars1 = animateScript("sparklesSpriteSheet", 720, 720, 0, 0, 250, 250, 3600, 5760, 33.3, false, true);
 	var stars2 = animateScript("sparklesSpriteSheet", 720, 720, 225, 25, 300, 300, 3600, 5760, 50, false, true);
 	var stars3 = animateScript("sparklesSpriteSheet", 720, 720, 510, 0, 250, 250, 3600, 5760, 33.3, false, true);
 	document.getElementById("midLevelScoreboard").style.display = "block";

 	//var stars4 = animateScript("sparklesSpriteSheet", 720, 720, 0, 250, 250, 250, 3600, 5760, 33.3, false, true);
 	//var stars5 = animateScript("sparklesSpriteSheet", 720, 720, 510, 250, 250, 250, 3600, 5760, 33.3, false, true);

 	//var stars2 = animateScript("spriteSheet1", 720, 720, 50, 50, 200, 200, 3600, 5760, 33.3, false, true);


 	setTimeout(function(){
 		//stopAnimate(temp);
 		var stars4 = animateScript("sparklesSpriteSheet", 720, 720, 25, 175, 200, 200, 3600, 5760, 33.3, false, true);

 	}, 1500);

 	setTimeout(function(){
 		//stopAnimate(temp);
 		var stars5 = animateScript("sparklesSpriteSheet", 720, 720, 475, 50, 200, 200, 3600, 5760, 33.3, false, true);

 	}, 2000);

 	document.getElementById("midLevelScoreboard").style.visibility = "visible";
 	var fadeTargetMidLevel = document.getElementById("midLevelScoreboard");
 	fadeTargetMidLevel.style.opacity = 0;
 	fadeInEffect1(fadeTargetMidLevel, -1, -1, 50);

 	document.getElementById("midLevelScoreboardScore").innerHTML = "Your Score: " + score;
 	document.getElementById("midLevelScoreboardLevel").innerHTML = "Your Level: " + level;
 	document.getElementById("midLevelScoreboardChain").innerHTML = "Longest Chain: " + maxChainCount;

 	document.getElementById("midLevelScoreboardLevel").style.opacity = 0;
 	document.getElementById("midLevelScoreboardTitle").style.opacity = 0;
 	document.getElementById("midLevelScoreboardChain").style.opacity = 0;
 	document.getElementById("midLevelScoreboardScore").style.opacity = 0;

 	document.getElementById("midLevelScoreboardTitle").style.animationName = 'fadeInAnimation';
 	setTimeout(function(){
 		document.getElementById("midLevelScoreboardTitle").style.opacity = 1;
 		document.getElementById("midLevelScoreboardLevel").style.animationName = 'fadeInAnimation';

 		setTimeout(function(){
 			document.getElementById("midLevelScoreboardLevel").style.opacity = 1;
 			document.getElementById("midLevelScoreboardScore").style.animationName = 'fadeInAnimation';

 			setTimeout(function(){
 				document.getElementById("midLevelScoreboardScore").style.opacity = 1;
 				document.getElementById("midLevelScoreboardChain").style.animationName = 'fadeInAnimation';
 				setTimeout(function(){
 					document.getElementById("midLevelScoreboardChain").style.opacity = 1;
 				}, 500);
 				setTimeout(function(){
 					var fadeTargetMidLevel = document.getElementById("nextLevel");
 					fadeTargetMidLevel.style.opacity = 0;
 					fadeInEffect1(fadeTargetMidLevel, -1, -1, 50);
 				}, 1000);
 			}, 500);
 		}, 500);
 	}, 500);

 }


//we will use this variable to clear the setInterval()
function stopAnimate(tID) {
	clearInterval(tID);
	document.getElementById(tID).remove();
	
	//document.getElementById("spriteTest").style.visibility = 'hidden';

} //end of stopAnimate()

function stopAnimate1(tID) {
	cancelAnimationFrame(tID);
	document.getElementById(tID).remove();
	
	//document.getElementById("spriteTest").style.visibility = 'hidden';

} //end of stopAnimate()
function animateScript(elementId, frameWidth, frameHeight, xLocation, yLocation, width, height, spriteWidth, spriteHeight, interval, gameBoard, runOnce, grow, maxSize) {
	var tID; 
	var canv = document.createElement('canvas');
	if(gameBoard){
		canv.classList.add("canvas");
		canv.width = 360; 
		canv.height = 360;
		canv.style.zIndex = zIncrement;
		zIncrement++;
		document.getElementById("canvasBlock").appendChild(canv);
	}else{
		canv.classList.add("canvasAnimator");
		canv.width = 760; 
		canv.height = 424;
		
		document.getElementById("animatorDiv").appendChild(canv);
		if(elementId === "timeUp" || elementId === "levelUpSpritesheet"){
			canv.style.zIndex = 50;
		}
	}

	
	var c5 = canv;//document.getElementById("animationCanvas");
	var ctx5 = c5.getContext("2d");
	//ctx5.shadowBlur = 0;
	//ctx5.shadowColor = "black";
	//ctx5.globalAlpha = 1;

	canv.style.visibility = 'visible';
	var positionX = 0; //start position for the image slicer
	var positionY = 0;
	if(elementId === "ballExplosion"){
		//positionX = 3 * frameWidth;
	}
	//var interval = 33.3; //100 ms of interval for the setInterval()
	var image1 = document.getElementById(elementId);// new Image();
	var deltaTime = 0;               
	var lastUpdate = Date.now();
	var size = 0;

	//var doAnimate = function(){
		tID = setInterval (function (){
			ctx5.clearRect(0,0, c5.width, c5.height);
			if(grow && width + size < maxSize){
				//console.log("size");
				//console.log(frameWidth / spriteWidth);
				//console.log(frameHeight / spriteHeight);

				size+= maxSize  / 20;//((frameWidth / spriteWidth) / (frameHeight / spriteHeight));
				ctx5.drawImage(image1, positionX, positionY, frameWidth, frameHeight, xLocation - (size / 2), yLocation - (size / 2), width + size, height + size);

			}else{
				ctx5.drawImage(image1, positionX, positionY, frameWidth, frameHeight, xLocation, yLocation, width, height);

			}

		//document.getElementById("spriteTest").style.backgroundPosition = 	`-${position}px ${positionY}px`; 
		if (positionX < spriteWidth - frameWidth){ 
			if(elementId === "treeSpritesheet" && positionY === 1272 && positionX === 4250){
				positionY = 0;
				positionX = 0; 
			}
			positionX = positionX + frameWidth;
		}
		else{ 
			if(positionY < spriteHeight - frameHeight){
				positionY += frameHeight;
				positionX = 0; 
			}else{
				positionY = 0;
				positionX = 0; 
				if(elementId === "ballExplosion"){
					positionX = 3 * frameWidth;
				}
			}
		}
	/*
		setTimeout(function(){
			doAnimate();
		}, interval);
		*/
		if(runOnce && positionX === 0 && positionY === 0){
			stopAnimate(tID);
			if(elementId === "timeUp"){
				document.getElementById('timeStamp').style.opacity = 1;
			}
		}else{
			if(elementId === "ballExplosion"){
				if(runOnce && positionX === 3 * frameWidth && positionY === 0){
					stopAnimate1(tID);
				}
			}
		}

	}, interval);
		canv.id = tID;
		return tID;

	//document.getElementById("spriteTest").style.backgroundPosition = 	`-${position}px ${positionY}px`; 


} //end of animateScript()



function animateSuperBall(elementId, frameWidth, frameHeight, xLocation, yLocation, width, height, spriteWidth, spriteHeight, interval, gameBoard, runOnce, grow, maxSize) {

	var tID; 


	var canv = document.createElement('canvas');
	if(animateSuperBallRunning){
		return;
	}
	if(gameBoard){
		canv.classList.add("canvas");
		canv.width = 360; 
		canv.height = 360;
		canv.style.zIndex = "0 !important";
		//canv.style.zIndex = zIncrement;
		//zIncrement++;
		document.getElementById("canvasBlock").appendChild(canv);
	}else{
		canv.classList.add("canvasAnimator");
		canv.width = 760; 
		canv.height = 424;
		
		document.getElementById("animatorDiv").appendChild(canv);
	}

	
	var c5 = canv;//document.getElementById("animationCanvas");
	var ctx5 = c5.getContext("2d");

	canv.style.visibility = 'visible';
	var positionX = 0; //start position for the image slicer
	var positionY = 0;
	if(elementId === "ballExplosion"){
		positionX = 3 * frameWidth;
	}
	//var interval = 33.3; //100 ms of interval for the setInterval()
	var image1 = document.getElementById(elementId);// new Image();
	var deltaTime = 0;               
	var lastUpdate = Date.now();
	var size = 0;
	var cleared = false;


	var stop = false;
	var frameCount = 0;
	var fps, fpsInterval, startTime, now, then, elapsed;
	var tID = 0;



	//var doAnimate = function(){
		var animate = function() {


			tID = requestAnimationFrame(animate);

			now = Date.now();
			elapsed = now - then;

			if (elapsed > fpsInterval) {

				then = now - (elapsed % fpsInterval);

				if(superBallList.length === 0){
				//animateSuperBallRunning = false;
				if(!cleared){
					ctx5.clearRect(0,0, c5.width, c5.height);
					cleared = true;
				}
				//ctx5.clearRect(0,0, c5.width, c5.height);
				//console.log("stopped");
				//clearInterval(tID);
				//console.log("watchger");
				return;
			}
			cleared = false;
			animateSuperBallRunning = true;
			ctx5.clearRect(0,0, c5.width, c5.height);



			for(var superBallCount = 0; superBallCount < superBallList.length; superBallCount++){
				if(superBallList[superBallCount] === null){
					continue;
				}
				ctx5.drawImage(image1, positionX, positionY, frameWidth, frameHeight, superBallList[superBallCount].x - 26, superBallList[superBallCount].y - 26, 100, 100);
			}


		//document.getElementById("spriteTest").style.backgroundPosition = 	`-${position}px ${positionY}px`; 
		if (positionX < spriteWidth - frameWidth){ 
			positionX = positionX + frameWidth;
		}
		else{ 
			if(positionY < spriteHeight - frameHeight){
				positionY += frameHeight;
				positionX = 0; 
			}else{
				positionY = 0;
				positionX = 0; 
				if(elementId === "ballExplosion"){
					positionX = 3 * frameWidth;
				}
			}
		}
	}

};

fpsInterval = interval;
then = Date.now();
startTime = then;

animate();

canv.id = tID;
return tID;
} //end of animateScript()


function loseGameAnimation(){
	mainTheme = document.getElementById("maintheme").pause();
	document.getElementById("preventInput").style.display = "none";
	endAnimations();
}

function fadeOutEffect2(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var doFadeOut = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if(fading){
				if (fadeTarget.style.opacity > 0) {
					fadeTarget.style.opacity -= 0.1;
				}else{
					fading = false;
					clearInterval(doFadeOut);
					if(flashMax !== 0){
						fadeInEffect2(fadeTarget, flashMax, flashCount, interval);
					}
				}
			}
		}, interval);

	}

	function fadeInEffect2(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var fadeNumber = fadeTarget.style.opacity;
		var doFadeIn = setInterval(function () {

			if (fadeTarget.style.opacity < 1) {
				fadeNumber = parseFloat(fadeNumber) + parseFloat('0.1');
				fadeTarget.style.opacity = fadeNumber;
					//console.log("fadingUp " + fadeNumber);
				}else{
					//console.log("fadingcall " + fading);
					clearInterval(doFadeIn);
					if(!constantFlashingTimer && flashMax === -1){
						return;
					}
					if((flashCount < flashMax) || flashMax === -1){
						fadeOutEffect2(fadeTarget, flashMax, flashCount + 1, interval);
					}

				}
			}, interval);
	}


