var firstButton;
var secondButton;

var clearTrack = 0;
var select = 0;

var mute = false;
var score = 0;
var level = 1;
var timeLeft = true;
var printOnce1 = true;
var printOnce2 = true;
var clicked = false;
var trackTime = 0.5;
var canClick = true;

var forcedMatchReset2 = false;
var showingHint = false;
var stopTimer = false;
var pausedButtonActive = false;
var comboAnimating = false;
var scoreAnimating = false;
var firstPlayCheck = false;
var highlightColor = '#FFFF00';
var opacityShift = 30;
var highlightSize = 1;
var edgeOfBoard = false;
var addToTimerBoolean = true;
var animateThreads = 0;
var pulseHint;
var timerColor = [255, 255, 0];

var changeTimerColor = false;
var changeColorCounter = 0;
var touchPositions = [];
var disableScolling = false;
var trophyIndex = 0;
var constantFlashingTimer = false;

var timeScale = 1;
var startTime = 0;
var lastFrameTime;
var timeLeftCount = 60000;
var frameCounter = 0;
var animationList = [];
var randomAnimating = false;
var randomWait = 0;
var stayPaused = false;
var quitGame = false;
var startQuit = false;
var infoDisplayShown = false;

 document.getElementById("timer").style.transform = "scaleY("+ timeScale + ")";


/**
 * A promise wrapper for requestAnimationFrame.
 * @returns {Promise} Resolves when requestAnimationFrame calls back
 */
 function promiseRAF() {
 	return new Promise(function (resolve, reject) {
 		requestAnimationFrame(resolve);
 	});
 }

 function Shape(x, y, x1, y1, image, shift){
 	this.x = x;
 	this.y = y;
 	this.x1 = x1;
 	this.y1 = y1;
 	this.image = image;
 	this.shift = shift;
 }

 var allShapes = [];
 var gridShapes = [[],[],[],[],[],[],[],[]];
 var clearShapes = [];
 var toDrawShapes = [];
 var images = [];
 var selectBalls = [];

 var destination1 = [];
 var destination2 = [];

 var breakBall1 = [];
 var breakBall2 = [];
 var newBallsToMatch = [];

 var start = true;
 var loop = 0;
 var firstSelect = false;
 var paused = true;
 var top = 180;
 var swapBack = false;
 var updateMassMoveBalls = false;
 var loop2 = 0;
 var waitForSwapBack = false;

 var newLevel = false;
 var startup = true;
 var touchedBall = false;
 var multiMatchAnimating = false;
 var lastTouch = null;

 var alreadyStarted = false;
 var playCheckRunOnce = false;

 document.addEventListener("DOMContentLoaded", function(){
  // Handler when the DOM is fully loaded
  
  var imagesLoaded = document.getElementById("midLevelScoreboard").complete;
  if(imagesLoaded){
  	setTimeout(function(){
  		document.getElementById("progressBar").style.display = "none";
  		document.getElementById("mainWrap").style.opacity = "1";
  	}, 800);
  	

  }else{
  	setTimeout(function(){
  		document.getElementById("progressBar").style.display = "none";
  		document.getElementById("mainWrap").style.opacity = "1";
  	}, 2500);
  	
  }

});

function resetGame(){
 	start = false;
 	paused = false;
 	timeScale = 1;
 	startup = true;
 	
 	timeLeft = true;
 	if(level === 4){
 		level = 1;
 	}
 	//timeLeftCount = 180000;
 	startTime = 0;
 	switch(level){
		case 1:
			timeLeftCount = 60000;
			break;
		case 2:
			timeLeftCount = 90000;
			break;
		case 3:
			timeLeftCount = 120000;
			break;
		default:
			timeLeftCount = 60000;
			break;
	}

	if(level === 1){
	 	newGame1();
	 	levelTotals = [0,0,0,0];
	}

 	setTimeout(function(){
		startup = false;
		doTimer();
	}, 500);

 	if(!newLevel){
 		//console.log("not a new level");
 		score = 0;
 		timeScale = 1;
 		//document.getElementById("level").innerHTML = "Level: " + level;
 		//document.getElementById("score").innerHTML = "Score: " + score;
 		mainTheme = document.getElementById("maintheme").play();
		doTimer();
		/*
 		setTimeout(function(){
 			startup = false;
 			doTimer();
 		}, 500);
 		*/
 		startAnimations();

 	}else{
 		newLevel = false;
 		//console.log("newGame111");
 		//document.getElementById("level").innerHTML = "Level: " + level;
 	}

 	setTimeout(function(){
 		document.getElementById('mainMenu').style.display = 'none';
 		document.getElementById('mainGame').style.display = 'block';
 		document.getElementById('gameOverScreen').style.display = 'none';
 		
 		document.getElementById('pauseButton').disabled = false;
		document.getElementById('instructions').disabled = false;
		document.getElementById("pauseGameOverlay").style.display = "none";

 	}, 200);
 } 

 function firstPlay(){

 	if(playCheckRunOnce){
 		playCheckRunOnce = false;
 		return;
 	}
 	if(alreadyStarted){
 		return;
 	}
 	if(quitGame){
 		 	
	 	paused = false;
	 	timeScale = 1;
	 	startup = true;
	 	
	 	timeLeft = true;
		level = 1;
	 	//timeLeftCount = 180000;
	 	startTime = 0;

	 	switch(level){
			case 1:
				timeLeftCount = 60000;
				break;
			case 2:
				timeLeftCount = 90000;
				break;
			case 3:
				timeLeftCount = 120000;
				break;
			default:
				timeLeftCount = 60000;
				break;
		}

 		firstWord = true;

		if(level === 1){
		 	newGame1();
		 	levelTotals = [0,0,0,0];
		}

	 	setTimeout(function(){
			startup = false;
			//doTimer();
			start = false;
		},1500);

	 	if(!newLevel){
	 		//console.log("not a new level");
	 		score = 0;
	 		timeScale = 1;
	 		//document.getElementById("level").innerHTML = "Level: " + level;
	 		//document.getElementById("score").innerHTML = "Score: " + score;
	 		mainTheme = document.getElementById("maintheme").play();
	 		startAnimations();

	 	}

	 	setTimeout(function(){
	 		//document.getElementById('mainMenu').style.display = 'none';
	 		//document.getElementById('mainGame').style.display = 'block';
	 		//document.getElementById('gameOverScreen').style.display = 'none';
	 		
	 		document.getElementById('pauseButton').disabled = false;
			document.getElementById('instructions').disabled = false;
	 	}, 200);
	 		quitGame = false;
 	}
 	alreadyStarted = true;
 	//document.getElementById("popSound").play();
 	//document.getElementById("popSound").pause();
 	var mainTheme = document.getElementById("maintheme");
 	maintheme.volume = .35;
 	maintheme.play();
 	maintheme.loop = true;
 	firstPlayCheck = true;
 	var fadeTarget = document.getElementById("mainMenu");
 	var fadeTarget1 = document.getElementById("play");
 	var fadeTarget2 = document.getElementById("howToPlay");
 	fadeOutEffect(fadeTarget, -1, -1, 60);
 	fadeOutEffect(fadeTarget1, -1, -1, 60);
 	fadeOutEffect(fadeTarget2, -1, -1, 60);
 	setTimeout(changeScreen,800);
 	startAnimations();
 	setTimeout(function(){
 		
 		startup = false;
 		score = 0;
 		//dragSetup();
 		//document.getElementById("score").innerHTML = "Score: " + score;

 	},700);
 	if(!quitGame){
 		adjustTiles();
 	}
 	doTimer();




 }
 function changeScreen(){
 	if(start){
 		//console.log("change1");
 		if(timeLeft == false){
 			timeLeft = true;
 			document.getElementById('gameOverScreen').style.display = 'none';
 		}
 		document.getElementById('mainMenu').style.display = 'none';
 		document.getElementById('mainGame').style.display = 'block';
 		document.getElementById('mainGame').style.opacity = 1;
		//doDebug();
		start = false;
		paused = false;

	}else{
		//console.log("change2");

		document.getElementById('mainMenu').style.display = 'block';
		document.getElementById('mainGame').style.display = 'none';
		if(timeLeft == false){

			document.getElementById('mainGame').style.display = 'none';
			document.getElementById('mainMenu').style.display = 'none';
			document.getElementById('gameOverScreen').style.display = 'block';

			document.getElementById("gameOverScoreBoard").innerHTML = "Level 1: " + levelTotals[1] + " words";
			document.getElementById("gameOverScoreBoard1").innerHTML = "Level 2: " + levelTotals[2] + " words";
			document.getElementById("maxChain").innerHTML = "Level 3: " + levelTotals[3] + " words";
			level = 1;
			return;
			
		}

		start = true;
	}
}


function mute1(){
	if(mute){
		mute = false;
		//document.getElementById("mute").style.opacity = 1;
		//document.getElementById("mute").querySelector("img").src = "Assets/" + gameType + "/Sound-01.png";
		
		document.activeElement.blur();
		document.getElementById("maintheme").play();
		document.getElementById("maintheme").muted = false;
		//document.getElementById("popSound").muted = false;
		document.getElementById("mute").classList.remove("muteOff");
		document.getElementById("mute").classList.add("muteOn");
		
	}else{
		mute = true;
		//document.getElementById("mute").style.opacity = 0.5;
		document.activeElement.blur();
		//document.getElementById("mute").querySelector("img").src = "Assets/" + gameType + "/Sound_off-01.png";
		document.getElementById("maintheme").muted = true;
		//document.getElementById("popSound").muted = true;
		document.getElementById("maintheme").pause();
		document.getElementById("mute").classList.remove("muteOn");
		document.getElementById("mute").classList.add("muteOff");


	}
}


function pauseGame(){
	if(pausedButtonActive){
		document.getElementById("pauseGameOverlay").style.display = "none";
		//document.getElementById("preventInputGame").style.display = "none";
		/*
		document.getElementById("pauseButtonText").innerHTML = "&#9612;&#9612;";
		document.getElementById("pauseButtonText").style.top = "20px";
		document.getElementById("pauseButtonText").style.fontSize = "1em";
		document.getElementById("pauseButtonText").style.left = "21px";
		*/
		document.getElementById("pauseButton").classList.remove('paused');
		document.getElementById('hiddenBackground').style.display = "none";
		//document.getElementById("pauseContent").style.display = "none";
		document.getElementById("pauseContent").classList.remove('showing');



		document.getElementById("quit").disabled = false;
		document.getElementById("info").disabled = false;

		pausedButtonActive = false;
		paused = false;
	}else{
		paused = true;
		pausedButtonActive = true;
		document.getElementById("pauseGameOverlay").style.backgroundImage = "url('Assets/game1/blankScreen.png')";

		document.getElementById("pauseGameOverlay").style.display = "flex";
		document.getElementById("pauseContent").classList.add('showing');
		//document.getElementById("pauseContent").style.display = "block";
		//document.getElementById("pauseButtonText").fontSize = "350% !important";
		document.getElementById("midLevel").style.display = "none";
		document.getElementById("pauseGameOverlay").style.opacity = 1;
		//document.getElementById("preventInputGame").style.display = "block";
		//document.getElementById("pauseButtonText").fontSize = "40pt !important";
		/*
		document.getElementById("pauseButtonText").innerHTML = "&#9658;";
		document.getElementById("pauseButtonText").style.fontSize = "1.5em";
		document.getElementById("pauseButtonText").style.top = "15px";
		document.getElementById("pauseButtonText").style.left = "19px";
		*/
		document.getElementById("pauseButton").classList.add('paused');
		document.getElementById('hiddenBackground').style.display = "block";

		document.getElementById("quit").disabled = true;
		document.getElementById("info").disabled = true;


		

	}

}
//timeScale = .95;

function rgb2hex2(red, green, blue) {
	var rgb = blue | (green << 8) | (red << 16);
	return '#' + (0x1000000 + rgb).toString(16).slice(1)
}

function newLevelReached(){

	//levelComplete();


	setTimeout(function(){
		//console.log("resettting");
		startup = false;
		newLevel = false;

	}, 1500);
	return;
}

function startNewLevel(){

/*
	superBallList = [];
	var fadeOutTarget1 = document.getElementById("midLevelScoreboardChain");	
	var fadeOutTarget2 = document.getElementById("midLevelScoreboardTitle");	
	var fadeOutTarget3 = document.getElementById("midLevelScoreboardLevel");	
	var fadeOutTarget4 = document.getElementById("midLevelScoreboardScore");
	var fadeOutTarget5 = document.getElementById("nextLevel");	
	var fadeOutTarget6 = document.getElementById("midLevelScoreboard");	
	var fadeOutTarget7 = document.getElementById("midLevelBackgroundChange");	

	var fadeTarget1 = document.getElementById("timeBox");
	var fadeTarget2 = document.getElementById("leftSideGameBoard");
	var fadeTarget3 = document.getElementById("rightSideGameBoard");
	var fadeTarget4 = document.getElementById("canvasBlock");
	var animateTarget = document.getElementById("canvasBlock");



	fadeOutEffect(fadeOutTarget1, -1, -1, 50);
	fadeOutEffect(fadeOutTarget2, -1, -1, 50);
	fadeOutEffect(fadeOutTarget3, -1, -1, 50);
	fadeOutEffect(fadeOutTarget4, -1, -1, 50);
	fadeOutEffect(fadeOutTarget5, -1, -1, 50);
	fadeOutEffect(fadeOutTarget6, -1, -1, 50);
	//fadeOutEffect(fadeOutTarget7, -1, -1, 200);

*/
	newLevel = true;
	//level++;
	timeScale = 1;
	level++;
	paused = false;
	pickedList = [];
	firstWord = true;
	document.getElementById('hiddenBackground').style.display = "none";
	document.getElementById('pauseButton').disabled = false;
	document.getElementById('instructions').disabled = false;

	resetGame();
	//document.getElementById("level").innerHTML = "Level: " + level;
	//document.getElementById("midLevelScoreboard").style.visibility = "hidden";

	var fadeTarget = document.getElementById("pauseGameOverlay");
	fadeOutEffect(fadeTarget, -1, -1, 60);
	adjustTiles();


	setTimeout(function(){
		/*
		document.getElementById("canvasBlock").style.transform = 'scaleY(1)';
		document.getElementById("canvasBlock").style.top = '0%';
		//document.getElementById("mainGame").classList.remove("mainGameBackground");
		setTimeout(function(){
		//document.getElementById("midLevelBackgroundChange").style.opacity = 0;
		//fadeOutEffect(fadeOutTarget7, -1, -1, 50);


	}, 50);
	*/
		//document.getElementById("pauseContent").style.display = "block";
		document.getElementById("pauseContent").style.display = "none";
		document.getElementById("midLevel").style.display = "none";
		
		document.getElementById("pauseGameOverlay").style.display = "none";



		//fadeInEffect(fadeTarget1, -1, -1, 50);
		//fadeInEffect(fadeTarget2, -1, -1, 50);
		//fadeInEffect(fadeTarget3, -1, -1, 50);
		//fadeInEffect(fadeTarget4, -1, -1, 50);

		setTimeout(function(){
			paused = false;
			startup = false;
			newLevel = false;
			document.getElementById("instructions").disabled = false;
			document.getElementById("pauseButton").disabled = false;
			document.getElementById("quit").disabled = false;
			document.getElementById("info").disabled = false;

		}, 500);
		return;
		setTimeout(function(){
			var scaleY = 100;

			return;
			var expandTarget = setInterval(function () {
				if (scaleY > 0) {
					scaleY+= (100 - scaleY )/5;  
				//console.log("fadingDown " + animateTarget.style.opacity);
			}else{
				clearInterval(expandTarget);
			}
			document.getElementById("canvasBlock").style.transform = 'scaleY(' + ((scaleY / 100) )+ ')';
			document.getElementById("canvasBlock").style.top = 1- (scaleY * 0.5) + '%';
		}, 50);
		}, 200);
	}, 500);

}

function makeImages(i){
	var image1 = new Image();
	image1.onload = function() {
		images.push(image1);
	};

	image1.src = "Assets/ball" + i + ".png";
	setTimeout(function(){
		if(i>=7){
			return;
		}
		makeImages(i + 1);
	}, 5);

}

function newGame1(){
	timeLeft = true;
	level = 1;
	adjustTiles();

			if(!newLevel){
				score = 0;
				chainCount = 0;
				maxChainCount = 0;
			}else{
				
				chainCount = 0;
			}

		}

	function showHelp(){
		//console.log("aaaaaaa");
		document.getElementById("waitState").style.animationName = "";

		document.getElementById("imageBlock").style.display = "none";

		document.getElementById("waitState").style.display = "block";
		document.getElementById("information").style.display = "block";
		document.getElementById("play1").style.display = "block";
		if(paused == true){
			document.getElementById("pauseGameOverlay").style.opacity = 0;
			stayPaused = true;
		}
		paused = true;
		document.getElementById('mainGame').style.display = 'block';
		document.getElementById('mainMenu').style.display = 'none';
		return;
	}

	function returnPlay(){
		if(firstPlay){
			//playCheckRunOnce = false;
			document.getElementById('mainMenu').style.animationName = 'fadeOut';
			document.getElementById('waitState').style.animationName = 'fadeOut';
			document.getElementById('gameOverScreen').style.display = 'none';
			//document.getElementById('mainMenu').style.display = 'none';
			document.getElementById('mainGame').style.display = 'block';
			
			document.getElementById("play1").style.display = "none";
			document.getElementById("information").style.display = "none";
			playCheckRunOnce = false;
			firstPlay();

			setTimeout(function(){
				document.getElementById("imageBlock").style.display = "block";

				document.getElementById('waitState').style.display = 'none';
				document.getElementById('waitState').style.opacity = 1;
				document.getElementById('mainMenu').style.opacity = 0;

				document.getElementById('mainMenu').style.display = 'none';

				if(stayPaused == true){
					document.getElementById("pauseGameOverlay").style.opacity = 1;
					stayPaused = false;
				}else{
					paused = false;
				}
			}, 1000);
			return;
		}
		document.getElementById("imageBlock").style.display = "block";

		paused = false;
		//changeScreen();
		//document.getElementById("mainGame").classList.remove("mainGameBackground");

		document.getElementById('gameOverScreen').style.display = 'none';
		document.getElementById('mainMenu').style.opacity = 0;
		document.getElementById('mainMenu').style.display = 'none';
		document.getElementById('mainGame').style.display = 'block';
		document.getElementById('waitState').style.display = 'none';
		document.getElementById("play1").style.display = "none";
		document.getElementById("information").style.display = "none";


		if(!firstPlayCheck){
			//document.getElementById("popSound").play();
			//document.getElementById("popSound").pause();
			firstPlayCheck = true;
			//setTimeout(changeScreen,100);
			var mainTheme = document.getElementById("maintheme");
			maintheme.volume = .35;
			maintheme.play();
			maintheme.loop = true;
			setTimeout(function(){
				startup = false;
 			//console.log("firstPlay");
 			score = 0;
 			document.getElementById("score").innerHTML = "Score: " + score;
 			doTimer();
 		},100);
		}

		//doDebug();
		start = false;
		startup = false;
		paused = false;

	}


	function startReadingLink(){
		//console.log("reading " + gameType);
		var link;
		switch(gameType){
			case "game0":
			link = "https://www.shelfstuff.com/book-shelf/books/the-greystone-secrets-1-the-strangers/";
			break;
			case "game1":
			link = "https://www.shelfstuff.com/book-shelf/books/endling-2-the-first/";
			break;

			default:
			link = "";
			break;
		}
		var win = window.open(link, '_blank');
		win.focus();
	}

	function endDrag(event){
		if(lastTouch === null){
			return;
		}

		disableScolling = false;
		touchPositions[1] = [lastTouch.touches[0].clientX, lastTouch.touches[0].clientY ];
		//console.log(touchPositions[1]);
		ballButton = document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY));
		document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY)).click();
		//console.log(document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY)));
		lastTouch = null;
	}

	function trackTouch(event){
		if(disableScolling){
			event.preventDefault();
		}
		lastTouch = event;
	}

	function randomsort(a, b) { 
	return Math.random()>.5 ? -1 : 1;
}


function replaceAll(str, find, replace) {
    return str.replace(new RegExp(find, 'g'), replace);
}

function doTimer(){
	if(startTime === 0){
		startTime = parseInt(new Date().getTime());
		lastFrameTime = parseInt(new Date().getTime());
	}
	 if(quitGame){
	 	return;
 	}
	if(!randomAnimating){
		randomAnimating = true;
		randomWait = Math.floor(Math.random() * 7500) + 5000;
	}


	var currentTime = parseInt(new Date().getTime());
		if(paused){
		lastFrameTime = currentTime;
	}
	timeLeftCount = timeLeftCount - (currentTime - lastFrameTime);
	if(randomWait > 0){
		randomWait = randomWait - (currentTime - lastFrameTime);
	}
	if(randomWait <= 0 && randomAnimating){
		randomAnimating = false;
		randomWait = 0;
		//randomAnimate();
	}

	switch(level){
		case 1:
			timeScale = timeLeftCount / 60000;
			break;
		case 2:
			timeScale = timeLeftCount / 90000;
			break;
		case 3:
			timeScale = timeLeftCount / 120000;
			break;
		default:
			timeScale = timeLeftCount / 60000;
			break;
	}
	var seconds = (parseInt(timeLeftCount / 1000) % 60);
	if(seconds < 10){
		seconds = "0" + seconds;
	}
	lastFrameTime = currentTime;


			//timeLeftCount-= 11;
	document.getElementById("timeStamp").innerHTML = parseInt(timeLeftCount / 60000) + ":" + seconds;



	var greenOffset = (timerColor[1] * timeScale) - 20;
	greenOffset += 80 * (timeScale);

	var redOffset = ( 255 * (1 - timeScale)); 
	redOffset += 50 * (1 - timeScale);

	if(redOffset > 255){
		redOffset = 255;
	}
	if(greenOffset > 255){
		greenOffset = 255;
	}
	if(greenOffset < 0){
		greenOffset = 0;
	}





	if(!changeTimerColor){
		
		var hexColor = rgb2hex2(redOffset, greenOffset,0 );


		//console.log(hexColor);
		document.getElementById("timer").style.backgroundColor = hexColor;
		

		//document.getElementById("timer").style.backgroundColor = 'rgb(' +  redOffset + ',' + greenOffset + ',0) !important;';
	}
	/*
	if(changeTimerColor){
			document.getElementById("timer").style.background = 'white';
			/*
		if(changeColorCounter % 5 === 0){
			document.getElementById("timer").style.background = 'white';
		}else{
			document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';

		}
		
		changeColorCounter++;
	}else{
		document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';

	}

	*/

	if(pausedButtonActive){
		setTimeout(function(){
			doTimer();
		}, 50);
		return;
	}
	if(!paused && timeScale > 0){
		/*
		if(timeScale >= 0.99){
			//newLevelReached();
			timeScale = 1;
			timerBrowserHelper();
			setTimeout(function(){
				levelComplete();
			}, 1000);
			return;
		}
		*/
		if(timeScale > 0.8){
			/*
			if(trophyIndex === 0){
				document.getElementById("trophy").src = "Assets/Trophy6_2.png";
				trophyIndex = 1;
			}
		}else{
			if(trophyIndex === 1){
				document.getElementById("trophy").src = "Assets/Trophy6_1.png";
				trophyIndex = 0;
			}
			*/
		}
		//timeScale -= 0.0028 + (level * 0.0006);
		if(!constantFlashingTimer && timeScale < 0.2){
			flashTimer();
		}
		if(constantFlashingTimer && timeScale > 0.2){
			constantFlashingTimer = false;
		}
		if(timeLeftCount <= 50){
			timeScale = 0;
			constantFlashingTimer = false;
			document.getElementById('pauseButton').disabled = true;
			document.getElementById('instructions').disabled = true;
			document.getElementById("timeBox").style.animationName = 'shakeTimer';
			/*
			var timeAnimation = animateScript("timeUp", 129, 200, 630, 290, 129, 200, 903, 800, 42, false, true, 0);
			setTimeout(function(){
				document.getElementById('timeStamp').style.opacity = 0;
			}, 0);
			*/
			comboAnimating = false;
			paused = true;
			var tileList = document.getElementsByClassName('buttonChoice');
			for(var tile = 0; tile < tileList.length; tile++){
				tileList[tile].style.animationName = 'none';

				tileList[tile].disabled = true;
			}
			setTimeout(function(){
				document.getElementById("timeBox").style.animationName = 'none';
				
				if(level < 3){
					midLevelScreen();
				}else{
					loseGameAnimation();
					timeLeft = false;
					setTimeout(function(){
						changeScreen();
					}, 1500);
				}
			}, 1000);
		}

		timerBrowserHelper();
	}

	if(timeScale < 0.2){
		//document.getElementById("timer").style.background = "linear-gradient(to top, red 50%, orange 99%, green 100%)";
	}
	if(timeLeftCount <= 0){//document.getElementById("timer").style.transform == "scaleY(0)"){
		/*
		timeLeftCount = false;
		loseGameAnimation();
		timeLeft = false;
		setTimeout(function(){
			changeScreen();
		}, 1500);
		*/
	}else{
		setTimeout(function(){
			doTimer();
		},10);

	}
}
function timerBrowserHelper(){
	document.getElementById("timer").style.webkitTransform = "translateZ(0)";
	document.getElementById("timer").style.msTransform = "translateZ(0)";
	document.getElementById("timer").style.transform = "translateZ(0)";



	document.getElementById("timer").style.webkitTransform = "scale3d(1,"+ timeScale + ",1)";
	//-ms-transform:
	document.getElementById("timer").style.msTransform = "scale3d(1,"+ timeScale + ",1)";
	//document.getElementById("timer").style.transform = "scaleY(" +  timeScale +")";
	document.getElementById("timer").style.transform = "scale3d(1,"+ timeScale + ",1)";



}


function flashTimer(){
		var fadeTarget = document.getElementById("timer");
		
		//console.log("fadingcall22222 " + fading);
		var flashCount = 0;

		constantFlashingTimer = true;
		fadeOutEffect2(fadeTarget, -1, 0, 35);

		//fadeOutEffect;
/*
		var fadeInEffect = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if (fadeTarget.style.opacity > 0) {
				fadeTarget.style.opacity -= 0.1;
			} else {
				clearInterval(fadeOutEffect);
			}
		}, 50);
		*/

	}

	function flashTimerColor(){


		var colorChanger = setInterval(function(){
			if(changeTimerColor){
				changeTimerColor = false;
			}else{
				changeTimerColor = true;
			}

			changeColorCounter++;
			if(changeColorCounter > 10){
				clearInterval(colorChanger);
				changeColorCounter = 0;
				changeTimerColor = false;
			}

			//console.log("interval");
		}, 40);
	}



	var greenOffset = (timerColor[1] * timeScale) - 20;
	greenOffset += 80 * (timeScale);

	var redOffset = ( 255 * (1 - timeScale)); 
	redOffset += 50 * (1 - timeScale);

	if(redOffset > 255){
		redOffset = 255;
	}
	if(greenOffset > 255){
		greenOffset = 255;
	}
	if(greenOffset < 0){
		greenOffset = 0;
	}

	if(!changeTimerColor){
		document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
	}
	function changeColorEffect1(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var doFadeOut = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if(fading){
				if (fadeTarget.style.opacity > 0) {
					fadeTarget.style.opacity -= 0.1;
				}else{
					fading = false;
					clearInterval(doFadeOut);
					if(flashMax !== 0){
						changeColorEffect2(fadeTarget, flashMax, flashCount, interval);
					}
				}
			}
		}, interval);

	}

	function changeColorEffect2(flashMax, flashCount, interval){
		var fading = true;
		//var fadeNumber = fadeTarget.style.opacity;
		var changeColor = setInterval(function () {
			var greenOffset = (timerColor[1] * timeScale) - 20;
			greenOffset += 80 * (timeScale);

			var redOffset = ( 255 * (1 - timeScale)); 
			redOffset += 50 * (1 - timeScale);

			if(redOffset > 255){
				redOffset = 255;
			}
			if(greenOffset > 255){
				greenOffset = 255;
			}
			if(greenOffset < 0){
				greenOffset = 0;
			}
			if(flashCount % 2 === 0){
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
			}else{
				document.getElementById("timer").style.background = 'white';
			}

			if (flashCount > flashMax) {
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
				clearInterval(changeColor);
				changeTimerColor = false;
			}
			flashCount++;
		}, interval);
	}
var ev1;
	function buttonHover(event){
		var element;
		if(!event.fromElement){
			element = event.relatedTarget;
		}else{
			element = event.fromElement;	
		}

		if(!element){
			return;
		}
		if(!element.src){
			return;
		}
		var newSrc = element.src;
		newSrc = newSrc.replace("_hover", "");
		newSrc = newSrc.slice(0, -4) + "_hover.png";
		newSrc = newSrc.replace("_down", "");
		element.src = newSrc;
	}
	
	function buttonHoverOut(event){
		var element;
		var id;
		if(!event.fromElement){
			element = event.relatedTarget;
			id = element.id;
		}else{
			element = event.fromElement.parentElement;	
			id = element.id.split("imageMap-")[1];
		}
		if(!element){
			return;
		}
		if(!document.getElementById(id)){
			return;
		}
		if(!document.getElementById(id).src){
			return;
		}
		var newSrc = document.getElementById(id).src;
		newSrc = newSrc.replace("_hover", "");
		newSrc = newSrc.replace("_down", "");
		document.getElementById(id).src = newSrc;
	}

	function buttonClick(event){
		var element;
		ev1 = event;

		var id;
		if(!event.fromElement){
			element = event.target.parentElement;
			id = element.id.split("imageMap-")[1];
		}else{
			element = event.fromElement.parentElement;	
			id = event.path[1].id.split("imageMap-")[1];
		}
		if(!element){
			return;
		}
		if(!document.getElementById(id)){
			return;
		}
		if(!document.getElementById(id).src){
			return;
		}
		//ev1 = event;
		//var newSrc = event.fromElement.src;
		var newSrc = document.getElementById(id).src;
		newSrc = newSrc.replace("_hover", "");
		newSrc = newSrc.slice(0, -4) + "_down.png";
		document.getElementById(id).src = newSrc;
	}
	function buttonClickUp(event){
		var element;
		var id;
		if(!event.fromElement){
			element = event.target.parentElement;
			id = element.id.split("imageMap-")[1];
		}else{
			element = event.fromElement.parentElement;	
			id = event.path[1].id.split("imageMap-")[1];
		}
		if(!element){
			return;
		}
		if(!document.getElementById(id)){
			return;
		}
		if(!document.getElementById(id).src){
			return;
		}
		//ev1 = event;
		//var newSrc = event.fromElement.src;
		var newSrc = document.getElementById(id).src;
		newSrc = newSrc.replace("_down", "");
		newSrc = newSrc.replace("_down", "");
		newSrc = newSrc.slice(0, -4) + "_hover.png";
		document.getElementById(id).src = newSrc;
	}

function midLevelScreen(){
	//var levelUp = animateScript("levelUpSpritesheet", 760, 225, 0, 50, 760, 225, 7600, 1350, 60, false, true, 0);
	document.getElementById("pauseGameOverlay").style.backgroundImage = "url('Assets/game1/blankScreen.png')";
	document.getElementById("instructions").disabled = true;
	document.getElementById("pauseButton").disabled = true;
	document.getElementById("quit").disabled = true;
	document.getElementById("info").disabled = true;
	setTimeout(function(){

		var tileList = document.getElementsByClassName('buttonChoice');
		for(var tile = 0; tile < tileList.length; tile++){
			tileList[tile].style.animationName = 'none';

			tileList[tile].disabled = false;
		}


		document.getElementById("pauseGameOverlay").style.opacity = 0;
		document.getElementById("pauseGameOverlay").style.display = "flex";
		var fadeTarget1 = document.getElementById("pauseGameOverlay");
		fadeInEffect(fadeTarget1, -1, -1, 50);
		document.getElementById("pauseContent").style.display = "none";
		document.getElementById("midLevel").style.display = "block";
		document.getElementById("midLevelScoreboardLevel").innerHTML = "Found Words: " + levelTotals[level];
		document.getElementById('midLevel').style.opacity = 0;
		document.getElementById('hiddenBackground').style.display = "block";

		setTimeout(function(){
			var fadeTarget2 = document.getElementById("midLevel");
			document.getElementById('midLevel').style.animationName = 'fadeIn';
			//fadeInEffect(fadeTarget2, -1, -1, 50);

		}, 500);

		setTimeout(function(){
			document.getElementById('midLevel').style.opacity = 1;
			document.getElementById('midLevel').style.animationName = '';
		}, 1000);
	}, 1000);
}

function startAnimations(){
	//var clouds = animateScript("cloudsSpritesheet", 475, 200, 350, 0, 356, 187, 5700, 2000, 70, false, false, 0);
	var tree = animateScript("BG_left_Spritesheet", 250, 424, 0, 0, 250, 424, 8000, 1272, 70, false, false, 0);
	var tree2 = animateScript("BG_right_Spritesheet", 250, 424, 510, 0, 250, 424, 8000, 1272, 70, false, false, 0);

	//animationList.push(clouds);
	animationList.push(tree);
	animationList.push(tree2);
}

function endAnimations(){
	for(animation = 0; animation < animationList.length; animation++){
		stopAnimate1(animationList[animation]);
	}
	animationList = [];
}

function randomAnimate(){
	var animation;
	var animatRand = Math.floor(Math.random() * 5) + 1;
	switch(animatRand){
		case 1:
			animation = animateScript("randomAnimations1", 760, 125, 0, 299, 760, 125, 7600, 2250, 42, false, true, 0);
			break;
		case 2:
			animation = animateScript("randomAnimations2", 760, 125, 0, 299, 760, 125, 7600, 1500, 42, false, true, 0);
			break;
		case 3:
			animation = animateScript("randomAnimations3", 760, 125, 0, 299, 760, 125, 7600, 1500, 42, false, true, 0);
			break;
		case 4:
			animation = animateScript("randomAnimations4", 760, 125, 0, 299, 760, 125, 7600, 1500, 42, false, true, 0);
			break;
		case 5:
			animation = animateScript("randomAnimations5", 760, 125, 0, 299, 760, 125, 7600, 1000, 42, false, true, 0);
			break;
		default:
			animation = animateScript("randomAnimations1", 760, 125, 0, 299, 760, 125, 7600, 2250, 42, false, true, 0);
			break;
	}
	//animationList.push(animation);
}
function preQuit(){
	paused = true;
	startQuit = true;
	document.getElementById("instructions").disabled = true;
	document.getElementById("pauseButton").disabled = true;
	document.getElementById("quit").disabled = true;
	document.getElementById("info").disabled = true;
	document.getElementById("pauseGameOverlay").style.backgroundImage = "url('Assets/game1/blankScreen.png')";

	document.getElementById("pauseGameOverlay").style.display = "block";
	document.getElementById("pauseContent").style.display = "none";
	//document.getElementById("pauseContent").innerHTML = "Quit Game?";

	//document.getElementById("pauseContent").style.fontSize = "300%";
	document.getElementById("midLevel").style.display = "none";
	document.getElementById("quitGameContent").style.display = "block";
	document.getElementById("pauseContent").style.marginBottom = "0px";

	setTimeout(function(){
		document.getElementById("pauseGameOverlay").style.opacity = 1;

	}, 50);
}
function closeQuit(){
	document.getElementById("pauseGameOverlay").style.opacity = 0;
	//document.getElementById("pauseContent").style.fontSize = "200%";
	//document.getElementById("pauseContent").style.display = "none";
	document.getElementById("quitGameContent").style.display = "none";
	document.getElementById("instructions").disabled = false;
	document.getElementById("pauseButton").disabled = false;
	document.getElementById("quit").disabled = false;
	document.getElementById("info").disabled = false;
	paused = false;
}
function quit(){
	//var doc = window;//parent.document.getElementById(window.name);
	//console.log(doc);
	timeLeft = false;
	var tileList = document.getElementsByClassName('buttonChoice');
	var innerLetterList = document.getElementsByClassName('pickedLetterInner');
	playCheckRunOnce = true;
	for(var tile = 0; tile < tileList.length; tile++){
		tileList[tile].style.animationName = 'none';
		innerLetterList[tile].style.animationName = 'none';

		tileList[tile].style.opacity = 0;
		innerLetterList[tile].style.opacity = 0;
	}
	loseGameAnimation();
			document.getElementById("pauseGameOverlay").style.opacity = 0;
		document.getElementById("pauseContent").style.fontSize = "200%";
		document.getElementById("pauseContent").style.display = "none";
		document.getElementById("quitGameContent").style.display = "none";
	
						setTimeout(function(){
	changeScreen();
		 	document.getElementById("instructions").disabled = false;
		document.getElementById("pauseButton").disabled = false;
		document.getElementById("quit").disabled = false;
		document.getElementById("info").disabled = false;
						//
					}, 0);


	return;
 	document.getElementById('mainMenu').style.opacity = 0;
 	document.getElementById('mainMenu').style.display = 'none';

	var fadeTarget = document.getElementById("mainGame");
	fadeOutEffect(fadeTarget, -1, -1, 60);

 	
	quitGame = true;

	setTimeout(function(){
		document.getElementById("pauseGameOverlay").style.opacity = 0;
		document.getElementById("pauseContent").style.fontSize = "200%";
		document.getElementById("pauseContent").style.display = "none";
		document.getElementById("quitGameContent").style.display = "none";


		endAnimations();
		paused = true;
		start = true;
		var fadeTarget = document.getElementById("mainMenu");
	 	var fadeTarget1 = document.getElementById("play");
	 	var fadeTarget2 = document.getElementById("howToPlay");
 		document.getElementById('mainMenu').style.display = 'block';
 		document.getElementById('mainMenu').style.opacity = 1;

 		document.getElementById('mainGame').style.display = 'none';
 		document.getElementById("mainGame").style.opacity = 1;
 		alreadyStarted = false;
 		//document.getElementById("maintheme").stop();
	 	fadeInEffect(fadeTarget, -1, -1, 60);
	 	fadeInEffect(fadeTarget1, -1, -1, 60);
	 	fadeInEffect(fadeTarget2, -1, -1, 60);
	 	document.getElementById("instructions").disabled = false;
		document.getElementById("pauseButton").disabled = false;
		document.getElementById("quit").disabled = false;
		document.getElementById("info").disabled = false;
		}, 500);
}

function showInfo(){
	if(infoDisplayShown){
		document.getElementById("infoDisplay").style.display = "none";
		document.getElementById("instructions").disabled = false;
		document.getElementById("pauseButton").disabled = false;
		document.getElementById("quit").disabled = false;
		paused = false;
		infoDisplayShown = false;
	}else{
		infoDisplayShown = true;
		paused = true;
		document.getElementById("infoDisplay").style.display = "block";
	 	document.getElementById("instructions").disabled = true;
		document.getElementById("pauseButton").disabled = true;
		document.getElementById("quit").disabled = true;
	}
}