var dragging = false;
var timer1;
var timer2;

var badClicks = 0;

// 1-indexed
var pickedLetterIndex = 1;
var pickedTilesList = [];
var numTiles = 0;
var correctAnswer = "";
var wordList;
var levelTotals = [0,0,0,0];
var letterOrder;
var pickedList = [];
var firstWord = true;


function processAnswer(e){
	e.preventDefault();
	if(!dragging){
		//document.getElementById('tempAnswer').innerHTML = "Answer Found!";
		clearInterval(timer1);
		timer1 = setInterval(function(){
			//document.getElementById('tempAnswer').innerHTML = "Click on something";

		}, 2000);
	}
}

function processAnswer2(e){
	e.preventDefault();
	
	if(!dragging){
		badClicks++;
		if(badClicks > 4){
			timeLeft = false;
			loseGameAnimation();
			setTimeout(function(){
				changeScreen();
			}, 250);
			badClicks = 0;
		}
		document.getElementById('tempAnswer').innerHTML = "Bad Click!";
		clearInterval(timer1);
		timer1 = setInterval(function(){
			document.getElementById('tempAnswer').innerHTML = "Click on something";

		}, 2000);

	}
}



function tileMouseOver(event){
	var img = event.target;//event.target.getElementsByClassName('letterTile')[0];
	img.src = "Assets/game0/letterTile_hover.png";
}

function tileMouseLeave(event){
	var img = event.target;//event.target.getElementsByClassName('letterTile')[0];
	img.src = "Assets/game0/letterTile.png";
}

function tileMouseDown(event){
	var img = event.target;//event.target.getElementsByClassName('letterTile')[0];
	img.src = "Assets/game0/letterTile_down.png";
}

function adjustTiles(reset){
	if(!reset){
		reset = false;
	}
	pickedLetterIndex = 1;
	pickedTilesList = [];
	tileContainerSize = 420;
	switch(level){
		case 1: 
		numTiles = 4;
		break;
		case 2:
		numTiles = 5;
		break;
		case 3:
		numTiles = 6;
		break;
		case 4:
		numTiles= 7;
		break;
		case 5: 
		numTiles = 8;
		break;
		default:
		numTiles = 4;
		break;
	}
	// Setup clickable tiles
	var timeOut = 0;
	var tileList = document.getElementsByClassName('buttonChoice');
	if(!firstWord && !reset){
		timeOut = 1000;
		var innerLetterList = document.getElementsByClassName('pickedLetterInner');
		for(var tile = 0; tile < tileList.length; tile++){

			tileList[tile].style.animation = 'none';
			innerLetterList[tile].style.animation = 'none';

			tileList[tile].style.animation = 'fadeOut 1s';
			innerLetterList[tile].style.animation = 'fadeOut 1s';

			//tileList[tile].style.animationName = 'fadeOut';
			//innerLetterList[tile].style.animationName = 'fadeOut';
		}
	}
	setTimeout(function(){
		for(var tile = 0; tile < tileList.length; tile++){
			if(tileList[tile].id == "choice1"){
			}else{
				tileList[tile].parentNode.removeChild(tileList[tile]);
				tile--;
			}
		}
		tileList = document.getElementsByClassName('buttonChoice');

		var newWidth = tileContainerSize / numTiles;
		if(newWidth > 75){
			newWidth = 75;
		}
		var newHeight = newWidth;//document.getElementById('letterChoices').offsetHeight / numTiles;
		var node = document.getElementById('choice1');
		node.style.width = newWidth + "px";
		node.style.height = newHeight + "px";
		node.innerHTML = "";
		node.disabled = false;
		if(!firstWord && !reset){
			node.style.opacity = 0;
		}
		//document.getElementById('letterChoices').style.height = newHeight + 1 + "px";
		

		var cloneNode;

		for(var tileCount = 2; tileCount <= numTiles; tileCount++){
			cloneNode = node.cloneNode(true);
			cloneNode.id = "choice" + tileCount;
			document.getElementById('letterChoices').appendChild(cloneNode);
		}


		// Setup question area tiles

		tileList = document.getElementsByClassName('letterChoice');

		for(var tile = 0; tile < tileList.length; tile++){
			if(tileList[tile].id == "letter1"){
			}else{
				tileList[tile].parentNode.removeChild(tileList[tile]);
				tile--;
			}
		}

		tileContainerSize = 350;
		var newWidth = tileContainerSize / numTiles;
		var newHeight = newWidth;//document.getElementById('letterChoices').offsetHeight / numTiles;
		var node = document.getElementById('letter1');
		node.style.width = newWidth + "px";
		node.children[0].innerHTML = "";
		//node.style.height = newHeight + "px";
		//document.getElementById('letterChoices').style.height = newHeight + 1 + "px";
		

		var cloneNode;

		for(var tileCount = 2; tileCount <= numTiles; tileCount++){
			cloneNode = node.cloneNode(true);
			cloneNode.id = "letter" + tileCount;
			document.getElementById('pickedLetters').appendChild(cloneNode);
		}
		newWord(reset);
	}, timeOut);
}
var ev2;
function addLetter(event){
	//var choice = event.target.id[event.target.id.length -1];
	ev2 = event;
	document.getElementById("letter" + pickedLetterIndex).children[0].innerHTML = event.target.innerHTML;
	pickedLetterIndex++;
	event.target.disabled = true;
	pickedTilesList.push(event.target);
	checkAnswer();
}

function subtractLetter(event){
	if(pickedLetterIndex === 1){
		return;
	}
	//var choice = event.target.id[event.target.id.length -1];
	pickedLetterIndex--;
	document.getElementById("letter" + pickedLetterIndex).children[0].innerHTML = "";
	
	pickedTilesList[pickedTilesList.length - 1].disabled = false;
	pickedTilesList.pop();
}

function newWord(reset){
	
	switch(numTiles){
		case 4: 
		wordList = fourLetterWords;
		break;
		case 5:
		wordList = fiveLetterWords;
		break;
		case 6:
		wordList = sixLetterWords;
		break;
		default:
		wordList = fourLetterWords;
		break;
	}
	var tileList = document.getElementsByClassName('buttonChoice');

	var newWord = wordList[Math.floor(Math.random() * wordList.length)];
	var chosenWord = newWord;
	if(reset){
		newWord = correctAnswer;
		chosenWord = newWord;
		newWord = letterOrder;
	}else{
		while(true){
			if(pickedList.includes(newWord)){
				newWord = wordList[Math.floor(Math.random() * wordList.length)];
				chosenWord = newWord;
			}else{
				break;
			}
		}
		pickedList.push(newWord);
		correctAnswer = newWord
		;		
		newWord = newWord.split('').sort(randomsort);
		newWord = newWord.toString();
		newWord = replaceAll(newWord, ",", "");
		letterOrder = newWord;
		pickedList.push(correctAnswer);
	}
	

	//console.log(correctAnswer);
	

	while(true){
		if(newWord === chosenWord){
			newWord = newWord.split('').sort(randomsort);
			newWord = newWord.toString();
			newWord = replaceAll(newWord, ",", "");
		}else{
			break;
		}
	}
	newWord = newWord.toUpperCase();


	for(var letter = 0; letter < newWord.length; letter++){
		tileList[letter].innerHTML = newWord[letter];
	}
	if(!firstWord && !reset){
		tileList = document.getElementsByClassName('buttonChoice');
		var innerLetterList = document.getElementsByClassName('pickedLetterInner');

		for(var tile = 0; tile < tileList.length; tile++){
			//tileList[tile].style.animationName = 'none';
			//innerLetterList[tile].style.animationName = 'none';

			tileList[tile].style.animation = 'none';
			innerLetterList[tile].style.animation = 'none';

			tileList[tile].style.animation = 'fadeIn 1s';
			innerLetterList[tile].style.animation = 'fadeIn 1s';
		}
		setTimeout(function(){
			var tileList = document.getElementsByClassName('buttonChoice');
			var innerLetterList = document.getElementsByClassName('pickedLetterInner');
			for(var tile = 0; tile < tileList.length; tile++){
				tileList[tile].style.animationName = 'none';
				innerLetterList[tile].style.animationName = 'none';

				tileList[tile].style.opacity = 1;
				innerLetterList[tile].style.opacity = 1;
			}
		}, 1000);
	}
	firstWord = false;

}

function checkAnswer(){
	if(pickedLetterIndex - 1 != numTiles){
		return;
	}

	if(timeLeftCount <= 50){
		return;
	}

	var tileList = document.getElementsByClassName('letterChoice');
	var response = "";
	for(var tile = 1; tile <= numTiles; tile++){
		response = response.concat(document.getElementById("letter" + tile).children[0].innerHTML);
	}

	response = response.toLowerCase();

	var index = wordList.indexOf(response);
	
	paused = true;
	if(index === -1){
		document.getElementById("wrongAnswer").style.display = "block";
		setTimeout(function(){
			document.getElementById("wrongAnswer").style.display = "none";
			adjustTiles(true);
			if(!pausedButtonActive){
				paused = false;
			}
		}, 1000);
	}else{
		levelTotals[level] = levelTotals[level] + 1;
		document.getElementById("rightAnswer").style.display = "block";

		setTimeout(function(){
			document.getElementById("rightAnswer").style.display = "none";
			adjustTiles();
			if(!pausedButtonActive){
				paused = false;
			}
		}, 1000);

		setTimeout(function(){
			if(!pausedButtonActive){
				paused = false;
			}
		}, 2000);
	}
	
	
}

function skipWord(){
	if(paused){
		return;
	}

	if(timeLeftCount > 3500){
		timeLeftCount -= 3000;
	}else{ 
		return;
	}
	paused = true;
	setTimeout(function(){
		paused = false;
	}, 2000);

	adjustTiles();
}

